-- Define the dissector function for the new structure
function tm_get_adcs_estimated_angle(buffer, pinfo, tree, adcs_estimated_angle, offset)

-- Define ProtoFields for the new structure fields

local f_roll_angle = ProtoField.double("adcs_estimated_angle.roll_angle", "Roll Angle", base.DEC)
local f_pitch_angle = ProtoField.double("adcs_estimated_angle.pitch_angle", "Pitch Angle", base.DEC)
local f_yaw_angle = ProtoField.double("adcs_estimated_angle.yaw_angle", "Yaw Angle", base.DEC)

-- Add the fields to the protocol
adcs_estimated_angle.fields = { 
     f_roll_angle, f_pitch_angle, f_yaw_angle
}

local subtree = tree:add(adcs_estimated_angle, buffer(), "ADCS ESTIMATED ANGLE")

        
         offset = offset + 3
        local data = buffer(offset,1):le_int()
        offset = offset + 1 
    
  if data == 0 then
        -- dissect commanded roll angle (2 bytes)
        local roll_angle = buffer(offset, 8):le_float()
        subtree:add(f_roll_angle, roll_angle):set_text(string.format("Roll Angle : %0.6f",roll_angle))
        offset = offset + 8

        -- dissect commanded pitch angle (2 bytes)
        local pitch_angle = buffer(offset, 8):le_float()
        subtree:add(f_pitch_angle, pitch_angle):set_text(string.format("Pitch Angle : %0.6f",pitch_angle))
        offset = offset + 8

        -- dissect commanded yaw angle (2 bytes)
        local yaw_angle = buffer(offset, 8):le_float()
        subtree:add(f_yaw_angle, yaw_angle):set_text(string.format("Yaw Angle : %0.6f",yaw_angle))
        offset = offset + 8
        
  elseif data == -1 then
    subtree:add(" ADCS operation failure ")
    elseif data == -2 then
    subtree:add(" TC TM error ")
    elseif data == -3 then
    subtree:add(" Interface error ")
    elseif data == -4 then
    subtree:add(" Id not support ")
    elseif data == -5 then
    subtree:add(" ADCS HW in invalid power state ")
    elseif data == -6 then
    subtree:add(" ADCS Semaphore take failure ")
    elseif data == -6 then
    subtree:add(" ADCS Operating Mode Mismatch error ")
    elseif data == -6 then
    subtree:add(" ADCS responded data is not in a valid range ")
    end
end