function tm_get_command_wheel_speed(buffer, pinfo, tree, command_wheel_speed, offset)
    -- Define ProtoFields
    local f_num_wheels = ProtoField.uint8("command_wheel_speed.num_wheels", "Number of Reaction Wheels", base.DEC)
    local f_wheel_speed = ProtoField.uint16("command_wheel_speed.wheel_speed", "Wheel Speed", base.DEC)

    -- Add the fields to the protocol
    command_wheel_speed.fields = { 
        f_num_wheels, f_wheel_speed
    }


    -- Add a subtree for the structure
    local subtree = tree:add(command_wheel_speed, buffer(), "Command Wheel Speed")
    
    offset = offset + 3
    local data = buffer(offset,1):le_int()
    offset = offset + 1 
    
    if data == 0 then
    -- Dissect the number of reaction wheels (1 byte)
    local num_wheels = buffer(offset, 1):le_uint()
    subtree:add(f_num_wheels, num_wheels):set_text(string.format("Number of Reaction Wheels: %d", num_wheels))
    offset = offset + 1

    -- Dissect the array of wheel speeds (2 * N bytes)
    --local wheel_speeds_subtree = subtree:add(buffer(offset, 2 * num_wheels), "Wheel Speeds")
    for i = 1, num_wheels  do
        local wheel_speed = buffer(offset, 2):le_uint()
        subtree:add(f_wheel_speed, wheel_speed):set_text(string.format("Commanded Wheel %d Speed : %d", i , wheel_speed))
        offset = offset + 2
    end
    
    elseif data == -1 then
    subtree:add(" ADCS operation failure ")
    elseif data == -2 then
    subtree:add(" TC TM error ")
    elseif data == -3 then
    subtree:add(" Interface error ")
    elseif data == -4 then
    subtree:add(" Id not support ")
    elseif data == -5 then
    subtree:add(" ADCS HW in invalid power state ")
    elseif data == -6 then
    subtree:add(" ADCS Semaphore take failure ")
    elseif data == -6 then
    subtree:add(" ADCS Operating Mode Mismatch error ")
    elseif data == -6 then
    subtree:add(" ADCS responded data is not in a valid range ")
    end
end
