-- Define the dissector function for the new structure
function tm_get_adcs_sensor_vector(buffer, pinfo, tree, adcs_sensor_vector, offset)

-- Define ProtoFields for the new structure fields

local f_x_rate_measurement = ProtoField.double("adcs_sensor_vector.roll_angle", "Roll Angle", base.DEC)
local f_y_rate_measurement = ProtoField.double("adcs_sensor_vector.pitch_angle", "Pitch Angle", base.DEC)
local f_z_rate_measurement = ProtoField.double("adcs_sensor_vector.yaw_angle", "Yaw Angle", base.DEC)

-- Add the fields to the protocol
adcs_sensor_vector.fields = { 
     f_x_rate_measurement, f_y_rate_measurement, f_z_rate_measurement
}

local subtree = tree:add(adcs_sensor_vector, buffer(), "ADCS SENSOR VECTOR")

        
        offset = offset + 3
        local data = buffer(offset,1):le_int()
        offset = offset + 1 
    
    if data == 0 then
       -- dissect commanded roll angle (2 bytes)
        local x_rate_measurement = buffer(offset, 8):le_float()
        subtree:add(f_x_rate_measurement, x_rate_measurement):set_text(string.format("Rate Sensor X : %0.6f", x_rate_measurement))
        offset = offset + 8

        -- dissect commanded pitch angle (2 bytes)
        local y_rate_measurement = buffer(offset, 8):le_float()
        subtree:add(f_y_rate_measurement, y_rate_measurement):set_text(string.format("Rate Sensor Y : %0.6f", y_rate_measurement))
        offset = offset + 8

        -- dissect commanded yaw angle (2 bytes)
        local z_rate_measurement = buffer(offset, 8):le_float()
        subtree:add(f_z_rate_measurement, z_rate_measurement):set_text(string.format("Rate Sensor Z : %0.6f", z_rate_measurement))
        offset = offset + 8
    elseif data == -1 then
    subtree:add(" ADCS operation failure ")
    elseif data == -2 then
    subtree:add(" TC TM error ")
    elseif data == -3 then
    subtree:add(" Interface error ")
    elseif data == -4 then
    subtree:add(" Id not support ")
    elseif data == -5 then
    subtree:add(" ADCS HW in invalid power state ")
    elseif data == -6 then
    subtree:add(" ADCS Semaphore take failure ")
    elseif data == -6 then
    subtree:add(" ADCS Operating Mode Mismatch error ")
    elseif data == -6 then
    subtree:add(" ADCS responded data is not in a valid range ")
    end
end