function tm_get_adcs_css_vector(buffer, pinfo, tree, adcs_css, offset)

local f_x_sun_vector = ProtoField.float("adcs_css.x_sun_vector", "X Sun Vector", base.DEC)
local f_y_sun_vector = ProtoField.float("adcs_css.y_sun_vector", "Y Sun Vector", base.DEC)
local f_z_sun_vector = ProtoField.float("adcs_css.z_sun_vector", "Z Sun Vector", base.DEC)

-- Register fields to the protocol
adcs_css.fields = { f_x_sun_vector, f_y_sun_vector, f_z_sun_vector }

local subtree = tree:add(adcs_css, buffer(), "ADCS CSS VECTOR")

     offset = offset + 3
    local data = buffer(offset,1):le_int()
    offset = offset + 1 
    
    if data == 0 then 
    -- X-axis Sun Vector  
    local x_sun_vector = buffer(offset, 4):le_float()  
    subtree:add(f_x_sun_vector, x_sun_vector):set_text(string.format(" X Sun Vector : %0.6f", x_sun_vector))  -- Add to subtree with scaling
    offset = offset + 4  -- Update offset

    -- Y-axis Sun Vector 
    local y_sun_vector = buffer(offset, 4):le_float()  
    subtree:add(f_y_sun_vector, y_sun_vector):set_text(string.format(" Y Sun Vector : %0.6f", y_sun_vector)) -- Add to subtree with scaling
    offset = offset + 4  -- Update offset

    -- Z-axis Sun Vector 
    local z_sun_vector = buffer(offset, 4):le_float() 
    subtree:add(f_z_sun_vector, z_sun_vector):set_text(string.format(" Z Sun Vector : %0.6f", z_sun_vector))  -- Add to subtree with scaling
    offset = offset + 4  -- Update offset
    
    elseif data == -1 then
    subtree:add(" ADCS operation failure ")
    elseif data == -2 then
    subtree:add(" TC TM error ")
    elseif data == -3 then
    subtree:add(" Interface error ")
    elseif data == -4 then
    subtree:add(" Id not support ")
    elseif data == -5 then
    subtree:add(" ADCS HW in invalid power state ")
    elseif data == -6 then
    subtree:add(" ADCS Semaphore take failure ")
    elseif data == -6 then
    subtree:add(" ADCS Operating Mode Mismatch error ")
    elseif data == -6 then
    subtree:add(" ADCS responded data is not in a valid range ")
    end
end