function tm_get_adcs_fss_vector(buffer, pinfo, tree, adcs_fss, offset)

local fss_x_vector = ProtoField.float("adcs_fss.x_sun_vector", "X Sun Vector", base.DEC)
local fss_y_vector = ProtoField.float("adcs_fss.y_sun_vector", "Y Sun Vector", base.DEC)
local fss_z_vector = ProtoField.float("adcs_fss.z_sun_vector", "Z Sun Vector", base.DEC)

-- Register fields to the protocol
adcs_fss.fields = { fss_x_vector, fss_y_vector, fss_z_vector }

local subtree = tree:add(adcs_fss, buffer(), "ADCS FSS VECTOR")

    offset = offset + 3
    local data = buffer(offset,1):le_int()
    offset = offset + 1 
    if data == 0 then
    -- X-axis Sun Vector  
    local x_vector = buffer(offset, 4):le_float()  
    subtree:add(fss_x_vector, x_vector):set_text(string.format(" FSS X Vector : %0.6f", x_vector))  -- Add to subtree with scaling
    offset = offset + 4  -- Update offset

    -- Y-axis Sun Vector 
    local y_vector = buffer(offset, 4):le_float()  
    subtree:add(fss_y_vector, y_vector):set_text(string.format(" FSS Y Vector : %0.6f", y_vector)) -- Add to subtree with scaling
    offset = offset + 4  -- Update offset

    -- Z-axis Sun Vector 
    local z_vector = buffer(offset, 4):le_float() 
    subtree:add(fss_z_vector, z_vector):set_text(string.format(" FSS Z Vector : %0.6f", z_vector))  -- Add to subtree with scaling
    offset = offset + 4  -- Update offset
    
    elseif data == -1 then
    subtree:add(" ADCS operation failure ")
    elseif data == -2 then
    subtree:add(" TC TM error ")
    elseif data == -3 then
    subtree:add(" Interface error ")
    elseif data == -4 then
    subtree:add(" Id not support ")
    elseif data == -5 then
    subtree:add(" ADCS HW in invalid power state ")
    elseif data == -6 then
    subtree:add(" ADCS Semaphore take failure ")
    elseif data == -6 then
    subtree:add(" ADCS Operating Mode Mismatch error ")
    elseif data == -6 then
    subtree:add(" ADCS responded data is not in a valid range ")
    end
    
end