function tm_sband_get_product_key(buffer, pinfo, tree, sband_product_key, offset)
    -- Define ProtoFields
    local f_previous_product_key = ProtoField.uint32("sband_product_key.previous_product_key", "Previous Product Key", base.HEX)
    local f_current_product_key = ProtoField.uint32("sband_product_key.current_product_key", "Current Product Key", base.HEX)

    -- Register the fields in the protocol
    sband_product_key.fields = {
        f_previous_product_key,
        f_current_product_key
    }

    -- Create a subtree for the structure
    local subtree = tree:add(sband_product_key, buffer(), "Product Key Structure")

    -- Parse previous_product_key array
    for i = 0, 3 do
        subtree:add_le(f_previous_product_key, buffer(offset, 4):le_uint()):append_text(string.format(" [Index %d]", i))
        offset = offset + 4
    end

    -- Parse current_product_key array
    for i = 0, 3 do
        subtree:add_le(f_current_product_key, buffer(offset, 4):le_uint()):append_text(string.format(" [Index %d]", i))
        offset = offset + 4
    end

end
